## mathicgb 1.0~git20181123

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(mathicgb VERSION 1.0 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_compile_definitions(VERSION="1.0")

find_package(tbb REQUIRED)

add_library(mathicgb
  src/mathicgb/MonoArena.hpp
  src/mathicgb/Range.hpp
  src/mathicgb/mtbb.hpp
  src/mathicgb/PrimeField.hpp
  src/mathicgb/MonoMonoid.hpp
  src/mathicgb/MonoProcessor.hpp
  src/mathicgb/MonoOrder.hpp
  src/mathicgb/Unchar.hpp
  src/mathicgb/MathicIO.hpp
  src/mathicgb/NonCopyable.hpp
  src/mathicgb/StaticMonoMap.hpp
  src/mathicgb/KoszulQueue.hpp
  src/mathicgb/Poly.hpp
  src/mathicgb/ReducerHelper.hpp
  src/mathicgb/MonomialMap.hpp
  src/mathicgb/RawVector.hpp
  src/mathicgb/Atomic.hpp
  src/mathicgb/ScopeExit.hpp
  src/mathicgb/FixedSizeMonomialMap.h # change name?
  src/mathicgb/ReducerPack.hpp        src/mathicgb/ReducerPack.cpp
  src/mathicgb/ClassicGBAlg.hpp       src/mathicgb/ClassicGBAlg.cpp
  src/mathicgb/MonoLookup.hpp         src/mathicgb/MonoLookup.cpp
  src/mathicgb/SigPolyBasis.hpp       src/mathicgb/SigPolyBasis.cpp
  src/mathicgb/Basis.hpp              src/mathicgb/Basis.cpp
  src/mathicgb/ModuleMonoSet.hpp      src/mathicgb/ModuleMonoSet.cpp
  src/mathicgb/PolyBasis.hpp          src/mathicgb/PolyBasis.cpp 
  src/mathicgb/PolyHashTable.hpp      src/mathicgb/PolyHashTable.cpp
  src/mathicgb/PolyRing.hpp           src/mathicgb/PolyRing.cpp 
  src/mathicgb/Reducer.hpp            src/mathicgb/Reducer.cpp
  src/mathicgb/ReducerDedup.hpp       src/mathicgb/ReducerDedup.cpp
  src/mathicgb/ReducerHash.hpp        src/mathicgb/ReducerHash.cpp
  src/mathicgb/ReducerHashPack.hpp    src/mathicgb/ReducerHashPack.cpp
  src/mathicgb/ReducerNoDedup.hpp     src/mathicgb/ReducerNoDedup.cpp
  src/mathicgb/ReducerPackDedup.hpp   src/mathicgb/ReducerPackDedup.cpp
  src/mathicgb/SignatureGB.hpp        src/mathicgb/SignatureGB.cpp
  src/mathicgb/SigSPairs.hpp          src/mathicgb/SigSPairs.cpp
  src/mathicgb/SPairs.hpp             src/mathicgb/SPairs.cpp
  src/mathicgb/SigSPairQueue.hpp      src/mathicgb/SigSPairQueue.cpp
  src/mathicgb/SparseMatrix.hpp       src/mathicgb/SparseMatrix.cpp
  src/mathicgb/QuadMatrixBuilder.hpp  src/mathicgb/QuadMatrixBuilder.cpp 
  src/mathicgb/TypicalReducer.hpp     src/mathicgb/TypicalReducer.cpp
  src/mathicgb/F4Reducer.hpp          src/mathicgb/F4Reducer.cpp
  src/mathicgb/F4MatrixBuilder.hpp    src/mathicgb/F4MatrixBuilder.cpp
  src/mathicgb/QuadMatrix.hpp         src/mathicgb/QuadMatrix.cpp
  src/mathicgb/F4MatrixReducer.hpp    src/mathicgb/F4MatrixReducer.cpp
  src/mathicgb/CFile.hpp              src/mathicgb/CFile.cpp
  src/mathicgb/LogDomain.hpp          src/mathicgb/LogDomain.cpp
  src/mathicgb/LogDomainSet.hpp       src/mathicgb/LogDomainSet.cpp
  src/mathicgb/F4MatrixBuilder2.hpp   src/mathicgb/F4MatrixBuilder2.cpp
  src/mathicgb/F4ProtoMatrix.hpp      src/mathicgb/F4ProtoMatrix.cpp
  src/mathicgb/F4MatrixProjection.hpp src/mathicgb/F4MatrixProjection.cpp
  src/mathicgb/io-util.hpp            src/mathicgb/io-util.cpp
  src/mathicgb/Scanner.hpp            src/mathicgb/Scanner.cpp
  src/mathicgb/stdinc.h
  src/mathicgb.cpp                    src/mathicgb.h
  )

target_link_libraries(mathicgb memtailor mathic tbb)
target_include_directories(mathicgb
  PUBLIC
    src
    )

add_executable(mgb
    src/cli/GBMain.cpp
    src/cli/CommonParams.hpp   src/cli/CommonParams.cpp
    src/cli/GBAction.hpp       src/cli/GBAction.cpp
    src/cli/GBCommonParams.hpp src/cli/GBCommonParams.cpp
    src/cli/MatrixAction.hpp   src/cli/MatrixAction.cpp 
    src/cli/SigGBAction.hpp    src/cli/SigGBAction.cpp
    src/cli/HelpAction.hpp     src/cli/HelpAction.cpp
    )

target_link_libraries(mgb mathicgb)

#install(TARGETS mathicgb ARCHIVE DESTINATION lib)
#install(FILES src/mathicgb.h DESTINATION include)
#install(DIRECTORY src/mathicgb/
#  DESTINATION include/mathicgb
#  FILES_MATCHING PATTERN "*.h"
#  PATTERN stdinc.h EXCLUDE
#  )

option(PACKAGE_TESTS "Build the tests" ON)
if(PACKAGE_TESTS)
  enable_testing()
  add_executable(mathicgb-gtests
    src/test/F4MatrixBuilder.cpp
    src/test/F4MatrixReducer.cpp
    src/test/MathicIO.cpp
    src/test/MonoMonoid.cpp
    src/test/PrimeField.cpp
    src/test/QuadMatrixBuilder.cpp
    src/test/Range.cpp
    src/test/Scanner.cpp
    src/test/SparseMatrix.cpp
    src/test/gb-test.cpp
    src/test/ideals.hpp src/test/ideals.cpp
    src/test/mathicgb.cpp
    src/test/poly-test.cpp
    src/test/gtestInclude.cpp
    src/test/testMain.cpp
    )

  target_link_libraries(mathicgb-gtests mathicgb)
  endif()

################################
# add gtest testing ############
################################

include(FetchContent)

FetchContent_Declare(
  googletest
  GIT_REPOSITORY https://github.com/google/googletest.git
  GIT_TAG        release-1.8.0
)

FetchContent_GetProperties(googletest)
if(NOT googletest_POPULATED)
  FetchContent_Populate(googletest)
endif()

target_include_directories(mathicgb-gtests
  PRIVATE
  ${googletest_SOURCE_DIR}/googletest/include
  ${googletest_SOURCE_DIR}/googletest/src
  ${googletest_SOURCE_DIR}/googletest
  )

add_test(NAME mathicgb-gtests
      COMMAND mathicgb-gtests
  )

## mathicgb 1.0~git20131006

=== debian/changelog ===
mathicgb (1.0~git20131006-3) unstable; urgency=medium

  * Update my email address.
  * debian/control
    - Tidy up using wrap-and-sort.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sat, 29 Aug 2015 09:47:58 -0400

mathicgb (1.0~git20131006-2) unstable; urgency=medium

  * debian/control
    - Move self to Uploaders; set Debian Science as Maintainer.
    - Restrict Build-Depends on libtbb-dev to the architectures on which it
      exists.
    - Set Priority to extra to satisfy Policy section 2.5 (libtbb is a
      dependency which has priority extra).
    - Remove dpkg-dev (>= 1.18.0) from Build-Depends; unnecessary as we no
      longer have a symbols file and thus do not need the arch-bits tag.
    - Remove redundant Priority field.
  * debian/libmathicgb0.symbols
    - Remove file for ease of maintainability.
  * debian/patches/fix_archs_with_unsigned_char.patch
    - New patch; fix failing tests for architectures which default to unsigned
      char.
  * debian/patches/fix_example_perms.patch
    - Remove empty file.

 -- Doug Torrance <dtorrance@monmouthcollege.edu>  Sat, 18 Jul 2015 15:06:45 -0600

mathicgb (1.0~git20131006-1) unstable; urgency=low

  * Initial release (Closes: #781665).

 -- Doug Torrance <dtorrance@monmouthcollege.edu>  Wed, 01 Apr 2015 07:12:36 -0500

=== debian/control ===
Source: mathicgb
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Doug Torrance <dtorrance@piedmont.edu>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libgtest-dev,
               libmathic-dev,
               libmemtailor-dev,
               libtbb-dev [amd64 arm64 armhf hppa i386 powerpc ppc64el],
               pkg-config
Standards-Version: 3.9.6
Section: math
Homepage: https://github.com/broune/mathicgb
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/mathicgb.git
Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/mathicgb.git

Package: mathicgb
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Description: Compute Groebner bases (command line tool)
 Mathicgb is a program for computing Groebner basis and signature Grobner bases.
 Mathicgb is based on the fast data structures from mathic.
 .
 The paper "Practical Grobner Basis Computation" describes the algorithms in
 Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
 http://arxiv.org/abs/1206.6940
 .
 This package contains the command line tool.

Package: libmathicgb-dev
Section: libdevel
Architecture: any
Depends: libmathicgb0 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Compute Groebner bases (developer tools)
 Mathicgb is a program for computing Groebner basis and signature Grobner bases.
 Mathicgb is based on the fast data structures from mathic.
 .
 The paper "Practical Grobner Basis Computation" describes the algorithms in
 Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
 http://arxiv.org/abs/1206.6940
 .
 This package contains the developer tools.

Package: libmathicgb0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Compute Groebner bases (runtime library)
 Mathicgb is a program for computing Groebner basis and signature Grobner bases.
 Mathicgb is based on the fast data structures from mathic.
 .
 The paper "Practical Grobner Basis Computation" describes the algorithms in
 Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
 http://arxiv.org/abs/1206.6940
 .
 This package contains the runtime library.

Package: libmathicgb-dbg
Architecture: any
Section: debug
Depends: libmathicgb0 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Compute Groebner bases (debugging symbols)
 Mathicgb is a program for computing Groebner basis and signature Grobner bases.
 Mathicgb is based on the fast data structures from mathic.
 .
 The paper "Practical Grobner Basis Computation" describes the algorithms in
 Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
 http://arxiv.org/abs/1206.6940
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

EXAMPLESDIR = $(CURDIR)/debian/mathicgb/usr/share/doc/mathicgb/examples

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- GTEST_PATH=/usr/src

override_dh_fixperms:
	dh_fixperms
	#dh_fixperms skips files in examples directory
	chmod 644 $(EXAMPLESDIR)/*.ideal

override_dh_strip:
	dh_strip --dbg-package=libmathicgb-dbg

get-orig-source:
	wget https://github.com/broune/mathicgb/archive/master.tar.gz
	git checkout upstream
	git pull https://github.com/broune/mathicgb
	grep -Po '(?<=AC_INIT\(\[mathicgb\], \[).*(?=\]\))' configure.ac \
		> version
	git show HEAD^:configure.ac | \
		grep -Po '(?<=AC_INIT\(\[mathicgb\], \[).*(?=\]\))' > oldversion
	if test `cat oldversion` = `cat version` ; then \
		echo "`cat version`~git`date -d @\`git log -1 --pretty=format:%ct\` +%Y%m%d`" > version; \
	fi
	git checkout master
	mv -v master.tar.gz ../mathicgb_`cat version`.orig.tar.gz
	rm version oldversion

=== debian/watch ===
# Upstream does not currently tag their releases.  However, if they do in the
# future, something similar to the following should work.
# version=3
# https://github.com/broune/mathicgb/tags \
# /broune/mathicgb/archive/mathicgb-(.+)\.tar\.gz

## mathicgb 1.0~git20150904

=== debian/changelog ===
mathicgb (1.0~git20150904-2) unstable; urgency=medium

  * debian/control
    - Update Vcs-Browser to use https; fixes vcs-field-uses-insecure-uri
      Lintian warning.
  * debian/{control,mgb.1}
    - Replace "Grobner" with "Groebner", the correct anglicization of "Gröbner"
      (Closes: #807904).
  * debian/rules
    - Enable all hardening flags; fixes hardening-no-{bindnow,pie} Lintian
      warnings.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sun, 31 Jan 2016 16:14:51 -0500

mathicgb (1.0~git20150904-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Update Homepage.
  * debian/copyright
    - Update Source.
    - Remove Comment; license information now in source.
  * debian/patches
    - Remove files; patches applied upstream.
  * debian/rules
    - Update GTEST_PATH in override_dh_auto_configure target.
    - Add --enable-shared to override_dh_auto_configure target.
    - Update get-orig-source target with new location.
  * debian/watch
    - Update comment with new location.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sat, 05 Sep 2015 20:21:41 -0400

=== debian/control ===
Source: mathicgb
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Doug Torrance <dtorrance@piedmont.edu>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libgtest-dev,
               libmathic-dev,
               libmemtailor-dev,
               libtbb-dev [amd64 arm64 armhf hppa i386 powerpc ppc64el],
               pkg-config
Standards-Version: 3.9.6
Section: math
Homepage: https://github.com/Macaulay2/mathicgb
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/mathicgb.git
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/mathicgb.git

Package: mathicgb
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Description: Compute Groebner bases (command line tool)
 Mathicgb is a program for computing Groebner basis and signature Groebner
 bases.  Mathicgb is based on the fast data structures from mathic.
 .
 The paper "Practical Groebner Basis Computation" describes the algorithms in
 Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
 http://arxiv.org/abs/1206.6940
 .
 This package contains the command line tool.

Package: libmathicgb-dev
Section: libdevel
Architecture: any
Depends: libmathicgb0 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Compute Groebner bases (developer tools)
 Mathicgb is a program for computing Groebner basis and signature Groebner
 bases.  Mathicgb is based on the fast data structures from mathic.
 .
 The paper "Practical Groebner Basis Computation" describes the algorithms in
 Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
 http://arxiv.org/abs/1206.6940
 .
 This package contains the developer tools.

Package: libmathicgb0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Compute Groebner bases (runtime library)
 Mathicgb is a program for computing Groebner basis and signature Groebner
 bases.  Mathicgb is based on the fast data structures from mathic.
 .
 The paper "Practical Groebner Basis Computation" describes the algorithms in
 Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
 http://arxiv.org/abs/1206.6940
 .
 This package contains the runtime library.

Package: libmathicgb-dbg
Architecture: any
Section: debug
Depends: libmathicgb0 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Compute Groebner bases (debugging symbols)
 Mathicgb is a program for computing Groebner basis and signature Groebner
 bases.  Mathicgb is based on the fast data structures from mathic.
 .
 The paper "Practical Groebner Basis Computation" describes the algorithms in
 Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
 http://arxiv.org/abs/1206.6940
 .
 This package contains the debugging symbols.

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 EXAMPLESDIR = $(CURDIR)/debian/mathicgb/usr/share/doc/mathicgb/examples
 
@@ -6,7 +8,7 @@
 	dh $@ --with autoreconf
 
 override_dh_auto_configure:
-	dh_auto_configure -- GTEST_PATH=/usr/src
+	dh_auto_configure -- GTEST_PATH=/usr/src/gtest --enable-shared
 
 override_dh_fixperms:
 	dh_fixperms
@@ -17,9 +19,9 @@
 	dh_strip --dbg-package=libmathicgb-dbg
 
 get-orig-source:
-	wget https://github.com/broune/mathicgb/archive/master.tar.gz
+	wget https://github.com/Macaulay2/mathicgb/archive/master.tar.gz
 	git checkout upstream
-	git pull https://github.com/broune/mathicgb
+	git pull https://github.com/Macaulay2/mathicgb
 	grep -Po '(?<=AC_INIT\(\[mathicgb\], \[).*(?=\]\))' configure.ac \
 		> version
 	git show HEAD^:configure.ac | \

=== debian/tests/control ===
Tests: build
Depends: build-essential, libmathic-dev, libmathicgb-dev, libmemtailor-dev,
 pkg-config

## mathicgb 1.0~git20170104

=== debian/changelog ===
mathicgb (1.0~git20170104-1ubuntu1) zesty; urgency=medium

  * Disable tests for now on buildds as they segfault

 -- Bhavani Shankar <bhavi@ubuntu.com>  Thu, 09 Feb 2017 10:51:02 +0530

mathicgb (1.0~git20170104-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Bump to Standards-Version 3.9.8.
    - Remove libmathicgb-dbg package in favor of new automatically
      generated *-dbgsym packages.
  * debian/mathicgb.install
    - Move installation of manpage to dh_install.
  * debian/{mathicgb.manpages,mgb.1}
    - Remove files; manpage added upstream.
  * debian/rules
    - Add --dbgsym-migration option to dh_strip.
  * debian/tests/unittest
    - Use upstream unit tests for continuous integration.

 -- Doug Torrance <dtorrance@piedmont.edu>  Wed, 11 Jan 2017 16:46:27 -0500

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: mathicgb
 Priority: extra
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Doug Torrance <dtorrance@piedmont.edu>
 Build-Depends: debhelper (>= 9),
                dh-autoreconf,
@@ -9,7 +10,7 @@
                libmemtailor-dev,
                libtbb-dev [amd64 arm64 armhf hppa i386 powerpc ppc64el],
                pkg-config
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Section: math
 Homepage: https://github.com/Macaulay2/mathicgb
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/mathicgb.git
@@ -59,18 +60,3 @@
  http://arxiv.org/abs/1206.6940
  .
  This package contains the runtime library.
-
-Package: libmathicgb-dbg
-Architecture: any
-Section: debug
-Depends: libmathicgb0 (= ${binary:Version}), ${misc:Depends}
-Multi-Arch: same
-Description: Compute Groebner bases (debugging symbols)
- Mathicgb is a program for computing Groebner basis and signature Groebner
- bases.  Mathicgb is based on the fast data structures from mathic.
- .
- The paper "Practical Groebner Basis Computation" describes the algorithms in
- Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
- http://arxiv.org/abs/1206.6940
- .
- This package contains the debugging symbols.

=== debian/rules ===
--- 
+++ 
@@ -10,13 +10,15 @@
 override_dh_auto_configure:
 	dh_auto_configure -- GTEST_PATH=/usr/src/gtest --enable-shared
 
+override_dh_auto_test:
+
 override_dh_fixperms:
 	dh_fixperms
 	#dh_fixperms skips files in examples directory
 	chmod 644 $(EXAMPLESDIR)/*.ideal
 
 override_dh_strip:
-	dh_strip --dbg-package=libmathicgb-dbg
+	dh_strip --dbgsym-migration='libmathicgb-dbg (<< 1.0~git20150904-2~)'
 
 get-orig-source:
 	wget https://github.com/Macaulay2/mathicgb/archive/master.tar.gz

## mathicgb 1.0~git20170606

=== debian/changelog ===
mathicgb (1.0~git20170606-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/compat
    - Bump debhelper compatibility level to 10.
  * debian/control
    - Set priority to optional.
    - Bump versioned dependency on debhelper to >= 10.
    - Remove dh-autoreconf from Build-Depends.
    - Bump Standards-Version to 4.0.1.
  * debian/copyright
    - Use https in Format.
  * debian/mathicgb.docs
    - Rename from just 'docs' for clarity.
  * debian/patches/big-endian.patch
    - New patch; fix tests on big-endian architectures (Closes: #862090).
  * debian/patches/link-deps.patch
    - New patch; properly link against mathic and memtailor.
  * debian/rules
    - Remove call to dh_autoreconf; now default with debhelper 10.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sat, 12 Aug 2017 18:33:51 -0400

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,14 @@
 Source: mathicgb
-Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Priority: optional
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Doug Torrance <dtorrance@piedmont.edu>
-Build-Depends: debhelper (>= 9),
-               dh-autoreconf,
+Build-Depends: debhelper (>= 10),
                libgtest-dev,
                libmathic-dev,
                libmemtailor-dev,
                libtbb-dev [amd64 arm64 armhf hppa i386 powerpc ppc64el],
                pkg-config
-Standards-Version: 3.9.8
+Standards-Version: 4.0.1
 Section: math
 Homepage: https://github.com/Macaulay2/mathicgb
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/mathicgb.git

=== debian/rules ===
--- 
+++ 
@@ -5,12 +5,10 @@
 EXAMPLESDIR = $(CURDIR)/debian/mathicgb/usr/share/doc/mathicgb/examples
 
 %:
-	dh $@ --with autoreconf
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- GTEST_PATH=/usr/src/gtest --enable-shared
-
-override_dh_auto_test:
 
 override_dh_fixperms:
 	dh_fixperms

=== debian/tests/control ===
Tests: unittest
Depends: build-essential, libmathic-dev, libmathicgb-dev, libmemtailor-dev,
 libgtest-dev, libtbb-dev, pkg-config

=== debian/watch ===
# Upstream does not currently tag their releases.  However, if they do in the
# future, something similar to the following should work.
# version=3
# https://github.com/Macaulay2/mathicgb/tags \
# /Macaulay2/mathicgb/archive/mathicgb-(.+)\.tar\.gz

## mathicgb 1.0~git20181123

=== debian/changelog ===
mathicgb (1.0~git20181123-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/compat
    - Remove file; unnecessary after bump to compatibility level 12.
  * debian/control
    - Drop debhelper from Build-Depends in favor of debhelper-compat
      for compatibility level 12.
    - Add Rules-Requires-Root field.
    - Bump Standards-Version to 4.5.0.
  * debian/mathicgb.examples
    - Add newline at end of file.
  * debian/patches/cross.patch
    - Add patch by Helmut Grohne <helmut@subdivi.de> to allow
      cross-building (Closes: #929037).
  * debian/rules
    - Drop override_dh_strip target. It was added in package version
      1.0~git20170104-1, which is in oldstable. The target existed to
      pass the --dbgsym-migration option, and this migration is complete.
  * debian/salsa-ci.yml
    - Add Salsa pipelines config file.
  * debian/tests/control
    - Reformat using wrap-and-sort.
  * debian/upstream/metadata
    - Add Repository and Bug-Database fields.

 -- Doug Torrance <dtorrance@piedmont.edu>  Tue, 21 Apr 2020 22:25:58 -0400

mathicgb (1.0~git20170606-2) unstable; urgency=medium

  * debian/compat
    - Bump debhelper compatibility level to 11.
  * debian/control
    - Bump versioned dependency on debhelper to >= 11.
    - Bump Standards-Version to 4.1.5.
    - Update Vcs-* links to Salsa.
  * debian/rules
    - Drop get-orig-source target; replaced by uscan.
  * debian/watch
    - Use uscan with git mode to obtain upstream tarball.

 -- Doug Torrance <dtorrance@piedmont.edu>  Mon, 09 Jul 2018 22:47:45 -0400

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,18 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Doug Torrance <dtorrance@piedmont.edu>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 12),
                libgtest-dev,
                libmathic-dev,
                libmemtailor-dev,
                libtbb-dev [amd64 arm64 armhf hppa i386 powerpc ppc64el],
                pkg-config
-Standards-Version: 4.0.1
+Standards-Version: 4.5.0
 Section: math
 Homepage: https://github.com/Macaulay2/mathicgb
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/mathicgb.git
-Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/mathicgb.git
+Vcs-Git: https://salsa.debian.org/science-team/mathicgb.git
+Vcs-Browser: https://salsa.debian.org/science-team/mathicgb
+Rules-Requires-Root: no
 
 Package: mathicgb
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

EXAMPLESDIR = $(CURDIR)/debian/mathicgb/usr/share/doc/mathicgb/examples

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- GTEST_PATH=/usr/src/gtest --enable-shared

override_dh_fixperms:
	dh_fixperms
	#dh_fixperms skips files in examples directory
	chmod 644 $(EXAMPLESDIR)/*.ideal

=== debian/tests/control ===
Tests: unittest
Depends: build-essential,
         libgtest-dev,
         libmathic-dev,
         libmathicgb-dev,
         libmemtailor-dev,
         libtbb-dev,
         pkg-config

## mathicgb 1.0~git20200526

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,39 @@
 cmake_minimum_required(VERSION 3.12)
-
-project(mathicgb VERSION 1.0 LANGUAGES CXX)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-add_compile_definitions(VERSION="1.0")
+project(mathicgb VERSION 1.0 LANGUAGES CXX)
 
-find_package(tbb REQUIRED)
+option(enable_mgb "Build mgb" OFF)
+option(with_tbb "use TBB for multithreading" OFF)
 
-add_library(mathicgb
+set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
+
+find_package(Threads 2.1 REQUIRED QUIET)
+find_package(Memtailor   REQUIRED)
+find_package(Mathic      REQUIRED)
+if(with_tbb)
+  find_package(TBB       REQUIRED)
+elseif(with_tbb STREQUAL auto)
+  find_package(TBB)
+  set(with_tbb ${TBB_FOUND})
+endif()
+
+add_compile_options(
+  -DHAVE_CXX11=1
+  -DPACKAGE_NAME="${PROJECT_NAME}"
+  -DPACKAGE_TARNAME="${PROJECT_NAME}"
+  -DPACKAGE_VERSION="${PROJECT_VERSION}"
+  -DPACKAGE_STRING="${PROJECT_NAME} ${PROJECT_VERSION}"
+  -DPACKAGE_BUGREPORT=""
+  -DPACKAGE_URL=""
+  -DPACKAGE="${PROJECT_NAME}"
+  -DVERSION="${PROJECT_VERSION}"
+  $<$<NOT:$<BOOL:${with_tbb}>>:-DMATHICGB_NO_TBB>
+)
+
+add_library(mathicgb STATIC
   src/mathicgb/MonoArena.hpp
   src/mathicgb/Range.hpp
   src/mathicgb/mtbb.hpp
@@ -35,9 +59,9 @@
   src/mathicgb/SigPolyBasis.hpp       src/mathicgb/SigPolyBasis.cpp
   src/mathicgb/Basis.hpp              src/mathicgb/Basis.cpp
   src/mathicgb/ModuleMonoSet.hpp      src/mathicgb/ModuleMonoSet.cpp
-  src/mathicgb/PolyBasis.hpp          src/mathicgb/PolyBasis.cpp 
+  src/mathicgb/PolyBasis.hpp          src/mathicgb/PolyBasis.cpp
   src/mathicgb/PolyHashTable.hpp      src/mathicgb/PolyHashTable.cpp
-  src/mathicgb/PolyRing.hpp           src/mathicgb/PolyRing.cpp 
+  src/mathicgb/PolyRing.hpp           src/mathicgb/PolyRing.cpp
   src/mathicgb/Reducer.hpp            src/mathicgb/Reducer.cpp
   src/mathicgb/ReducerDedup.hpp       src/mathicgb/ReducerDedup.cpp
   src/mathicgb/ReducerHash.hpp        src/mathicgb/ReducerHash.cpp
@@ -49,7 +73,7 @@
   src/mathicgb/SPairs.hpp             src/mathicgb/SPairs.cpp
   src/mathicgb/SigSPairQueue.hpp      src/mathicgb/SigSPairQueue.cpp
   src/mathicgb/SparseMatrix.hpp       src/mathicgb/SparseMatrix.cpp
-  src/mathicgb/QuadMatrixBuilder.hpp  src/mathicgb/QuadMatrixBuilder.cpp 
+  src/mathicgb/QuadMatrixBuilder.hpp  src/mathicgb/QuadMatrixBuilder.cpp
   src/mathicgb/TypicalReducer.hpp     src/mathicgb/TypicalReducer.cpp
   src/mathicgb/F4Reducer.hpp          src/mathicgb/F4Reducer.cpp
   src/mathicgb/F4MatrixBuilder.hpp    src/mathicgb/F4MatrixBuilder.cpp
@@ -67,35 +91,47 @@
   src/mathicgb.cpp                    src/mathicgb.h
   )
 
-target_link_libraries(mathicgb memtailor mathic tbb)
+target_link_libraries(mathicgb
+  $<$<BOOL:${with_tbb}>:${TBB_LIBRARIES}>
+  ${MEMTAILOR_LIBRARIES}
+  ${MATHIC_LIBRARIES}
+  Threads::Threads
+  )
 target_include_directories(mathicgb
   PUBLIC
-    src
-    )
+    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>
+    $<INSTALL_INTERFACE:include>
+    ${MEMTAILOR_INCLUDE_DIR}
+    ${MATHIC_INCLUDE_DIR}
+  )
+set_target_properties(mathicgb PROPERTIES PUBLIC_HEADER src/mathicgb.h)
 
-add_executable(mgb
+install(TARGETS mathicgb LIBRARY DESTINATION lib)
+install(DIRECTORY src/mathicgb
+  DESTINATION include
+  FILES_MATCHING PATTERN "*.hpp" PATTERN "*.h"
+  )
+install(FILES doc/mgb.1 TYPE MAN)
+install(FILES README.md gpl-2.0.txt gpl-3.0.txt
+  DESTINATION licenses/mathicgb
+  )
+
+if(enable_mgb)
+  add_executable(mgb
     src/cli/GBMain.cpp
     src/cli/CommonParams.hpp   src/cli/CommonParams.cpp
     src/cli/GBAction.hpp       src/cli/GBAction.cpp
     src/cli/GBCommonParams.hpp src/cli/GBCommonParams.cpp
-    src/cli/MatrixAction.hpp   src/cli/MatrixAction.cpp 
+    src/cli/MatrixAction.hpp   src/cli/MatrixAction.cpp
     src/cli/SigGBAction.hpp    src/cli/SigGBAction.cpp
     src/cli/HelpAction.hpp     src/cli/HelpAction.cpp
     )
+  target_link_libraries(mgb mathicgb)
+  install(TARGETS mgb RUNTIME DESTINATION bin)
+endif()
 
-target_link_libraries(mgb mathicgb)
-
-#install(TARGETS mathicgb ARCHIVE DESTINATION lib)
-#install(FILES src/mathicgb.h DESTINATION include)
-#install(DIRECTORY src/mathicgb/
-#  DESTINATION include/mathicgb
-#  FILES_MATCHING PATTERN "*.h"
-#  PATTERN stdinc.h EXCLUDE
-#  )
-
-option(PACKAGE_TESTS "Build the tests" ON)
-if(PACKAGE_TESTS)
-  enable_testing()
+include(CTest)
+if(BUILD_TESTING)
   add_executable(mathicgb-gtests
     src/test/F4MatrixBuilder.cpp
     src/test/F4MatrixReducer.cpp
@@ -110,38 +146,38 @@
     src/test/ideals.hpp src/test/ideals.cpp
     src/test/mathicgb.cpp
     src/test/poly-test.cpp
-    src/test/gtestInclude.cpp
     src/test/testMain.cpp
     )
 
-  target_link_libraries(mathicgb-gtests mathicgb)
+  ################################
+  # add gtest testing ############
+  ################################
+  find_package(GTest)
+  include(GoogleTest)
+  gtest_discover_tests(mathicgb-gtests)
+
+  # Check for recent version of GoogleTest
+  include(CheckFunctionExists)
+  set(CMAKE_REQUIRED_INCLUDES "${GTEST_INCLUDE_DIRS}")
+  check_function_exists(TYPED_TEST_SUITE GTEST_VERSION_OK)
+
+  if(GTEST_FOUND AND GTEST_VERSION_OK)
+    target_link_libraries(mathicgb-gtests mathicgb GTest::GTest GTest::Main)
+    target_include_directories(mathicgb-gtests PRIVATE ${GTEST_INCLUDE_DIR})
+  else()
+    include(FetchContent)
+    FetchContent_Declare(googletest
+      GIT_REPOSITORY https://github.com/google/googletest.git
+      GIT_TAG        release-1.10.0
+      )
+    set(BUILD_GMOCK OFF CACHE STRING "...")
+    FetchContent_MakeAvailable(googletest)
+
+    target_link_libraries(mathicgb-gtests mathicgb gtest)
+    target_include_directories(mathicgb-gtests PRIVATE
+      ${googletest_SOURCE_DIR}/googletest/include
+      ${googletest_SOURCE_DIR}/googletest/src
+      ${googletest_SOURCE_DIR}/googletest
+      )
   endif()
-
-################################
-# add gtest testing ############
-################################
-
-include(FetchContent)
-
-FetchContent_Declare(
-  googletest
-  GIT_REPOSITORY https://github.com/google/googletest.git
-  GIT_TAG        release-1.8.0
-)
-
-FetchContent_GetProperties(googletest)
-if(NOT googletest_POPULATED)
-  FetchContent_Populate(googletest)
 endif()
-
-target_include_directories(mathicgb-gtests
-  PRIVATE
-  ${googletest_SOURCE_DIR}/googletest/include
-  ${googletest_SOURCE_DIR}/googletest/src
-  ${googletest_SOURCE_DIR}/googletest
-  )
-
-add_test(NAME mathicgb-gtests
-      COMMAND mathicgb-gtests
-  )
-

=== debian/changelog ===
mathicgb (1.0~git20200526-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/patches/cross.patch
    - Remove patch; applied upstream.
  * debian/rules
    - Remove override_dh_fixperms target; file permissions have been
      fixed upstream.
  * debian/salsa-ci.yml
    - Restore file so we don't trigger builds when pushing upstream
      or pristine-tar branches.

 -- Doug Torrance <dtorrance@piedmont.edu>  Wed, 01 Jul 2020 08:26:36 -0400

mathicgb (1.0~git20181123-2) unstable; urgency=medium

  * debian/control
    - Bump debhelper compatibility level to 13.
  * debian/not-installed
    - New file; now that we are using debhelper 13, we need to tell
      dh_missing that we are not installing the libtool .la file.
  * debian/salsa-ci.yml
    - Remove file; we will use the one hosted at the Salsa CI Team's
      repository.
  * debian/tests/control
    - Allow stderr messages in autopkgtest.  We were getting warnings from
      including tbb.h that were causing the tests to fail.  Adapted from a
      patch by Graham Inggs <ginggs@ubuntu.com> for the Ubuntu version of
      the package.

 -- Doug Torrance <dtorrance@piedmont.edu>  Thu, 14 May 2020 13:57:48 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Doug Torrance <dtorrance@piedmont.edu>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libgtest-dev,
                libmathic-dev,
                libmemtailor-dev,

=== debian/watch ===
version=4
opts="mode=git, pretty=1.0~git%cd" \
https://github.com/Macaulay2/mathicgb HEAD

## mathicgb 1.0~git20210109

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,8 +5,8 @@
 
 project(mathicgb VERSION 1.0 LANGUAGES CXX)
 
-option(enable_mgb "Build mgb" OFF)
-option(with_tbb "use TBB for multithreading" OFF)
+option(enable_mgb "Build mgb" ON)
+option(with_tbb "use TBB for multithreading" auto)
 
 set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
 
@@ -20,6 +20,10 @@
   set(with_tbb ${TBB_FOUND})
 endif()
 
+if(CMAKE_BUILD_TYPE STREQUAL Debug)
+  add_compile_options(-DMATHICGB_DEBUG -DMATHIC_DEBUG -DMEMT_DEBUG)
+endif()
+
 add_compile_options(
   -DHAVE_CXX11=1
   -DPACKAGE_NAME="${PROJECT_NAME}"
@@ -31,7 +35,7 @@
   -DPACKAGE="${PROJECT_NAME}"
   -DVERSION="${PROJECT_VERSION}"
   $<$<NOT:$<BOOL:${with_tbb}>>:-DMATHICGB_NO_TBB>
-)
+  )
 
 add_library(mathicgb STATIC
   src/mathicgb/MonoArena.hpp
@@ -101,6 +105,7 @@
   PUBLIC
     $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>
     $<INSTALL_INTERFACE:include>
+    $<$<BOOL:${with_tbb}>:${TBB_INCLUDE_DIRS}>
     ${MEMTAILOR_INCLUDE_DIR}
     ${MATHIC_INCLUDE_DIR}
   )

=== debian/changelog ===
mathicgb (1.0~git20210109-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Bump Standards-Version to 4.6.0.
    - Drop specific architectures from libtbb-dev in Build-Depends; it is
      now available on all the official ones.
  * debian/patches/big-endian.patch
    - Add Author, Bug, and Bug-Debian fields.
  * debian/patches/include-limits.patch
    - New patch; include header for std::numeric_limits. Otherwise,
      mathicgb fails to compile using GCC 11 (Closes: #984231).
  * debian/patches/link-deps.patch
    - Remove patch; applied upstream.

 -- Doug Torrance <dtorrance@piedmont.edu>  Thu, 19 Aug 2021 21:09:39 -0400

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
                libgtest-dev,
                libmathic-dev,
                libmemtailor-dev,
-               libtbb-dev [amd64 arm64 armhf hppa i386 powerpc ppc64el],
+               libtbb-dev,
                pkg-config
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Section: math
 Homepage: https://github.com/Macaulay2/mathicgb
 Vcs-Git: https://salsa.debian.org/science-team/mathicgb.git

## mathicgb 1.0~git20211001

=== src/CMakeLists.txt ===
if(CMAKE_BUILD_TYPE STREQUAL Debug)
  add_compile_options(-DMATHICGB_DEBUG -DMATHIC_DEBUG -DMEMT_DEBUG)
endif()

add_library(mathicgb STATIC
  mathicgb.h
  mathicgb.cpp
  mathicgb/MonoArena.hpp
  mathicgb/Range.hpp
  mathicgb/mtbb.hpp
  mathicgb/PrimeField.hpp
  mathicgb/MonoMonoid.hpp
  mathicgb/MonoProcessor.hpp
  mathicgb/MonoOrder.hpp
  mathicgb/Unchar.hpp
  mathicgb/MathicIO.hpp
  mathicgb/NonCopyable.hpp
  mathicgb/StaticMonoMap.hpp
  mathicgb/KoszulQueue.hpp
  mathicgb/Poly.hpp
  mathicgb/ReducerHelper.hpp
  mathicgb/MonomialMap.hpp
  mathicgb/RawVector.hpp
  mathicgb/Atomic.hpp
  mathicgb/ScopeExit.hpp
  mathicgb/FixedSizeMonomialMap.h # change name?
  mathicgb/ReducerPack.hpp        mathicgb/ReducerPack.cpp
  mathicgb/ClassicGBAlg.hpp       mathicgb/ClassicGBAlg.cpp
  mathicgb/MonoLookup.hpp         mathicgb/MonoLookup.cpp
  mathicgb/SigPolyBasis.hpp       mathicgb/SigPolyBasis.cpp
  mathicgb/Basis.hpp              mathicgb/Basis.cpp
  mathicgb/ModuleMonoSet.hpp      mathicgb/ModuleMonoSet.cpp
  mathicgb/PolyBasis.hpp          mathicgb/PolyBasis.cpp
  mathicgb/PolyHashTable.hpp      mathicgb/PolyHashTable.cpp
  mathicgb/PolyRing.hpp           mathicgb/PolyRing.cpp
  mathicgb/Reducer.hpp            mathicgb/Reducer.cpp
  mathicgb/ReducerDedup.hpp       mathicgb/ReducerDedup.cpp
  mathicgb/ReducerHash.hpp        mathicgb/ReducerHash.cpp
  mathicgb/ReducerHashPack.hpp    mathicgb/ReducerHashPack.cpp
  mathicgb/ReducerNoDedup.hpp     mathicgb/ReducerNoDedup.cpp
  mathicgb/ReducerPackDedup.hpp   mathicgb/ReducerPackDedup.cpp
  mathicgb/SignatureGB.hpp        mathicgb/SignatureGB.cpp
  mathicgb/SigSPairs.hpp          mathicgb/SigSPairs.cpp
  mathicgb/SPairs.hpp             mathicgb/SPairs.cpp
  mathicgb/SigSPairQueue.hpp      mathicgb/SigSPairQueue.cpp
  mathicgb/SparseMatrix.hpp       mathicgb/SparseMatrix.cpp
  mathicgb/QuadMatrixBuilder.hpp  mathicgb/QuadMatrixBuilder.cpp
  mathicgb/TypicalReducer.hpp     mathicgb/TypicalReducer.cpp
  mathicgb/F4Reducer.hpp          mathicgb/F4Reducer.cpp
  mathicgb/F4MatrixBuilder.hpp    mathicgb/F4MatrixBuilder.cpp
  mathicgb/QuadMatrix.hpp         mathicgb/QuadMatrix.cpp
  mathicgb/F4MatrixReducer.hpp    mathicgb/F4MatrixReducer.cpp
  mathicgb/CFile.hpp              mathicgb/CFile.cpp
  mathicgb/LogDomain.hpp          mathicgb/LogDomain.cpp
  mathicgb/LogDomainSet.hpp       mathicgb/LogDomainSet.cpp
  mathicgb/F4MatrixBuilder2.hpp   mathicgb/F4MatrixBuilder2.cpp
  mathicgb/F4ProtoMatrix.hpp      mathicgb/F4ProtoMatrix.cpp
  mathicgb/F4MatrixProjection.hpp mathicgb/F4MatrixProjection.cpp
  mathicgb/io-util.hpp            mathicgb/io-util.cpp
  mathicgb/Scanner.hpp            mathicgb/Scanner.cpp
  mathicgb/stdinc.h
  )

target_link_libraries(mathicgb
  $<$<BOOL:${with_tbb}>:${TBB_LIBRARIES}>
  memtailor mathic Threads::Threads
  )

target_include_directories(mathicgb PUBLIC
  $<$<BOOL:${with_tbb}>:${TBB_INCLUDE_DIRS}>)

target_include_directories(mathicgb PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:include>
  )

include(CTest)
if(BUILD_TESTING)
  add_executable(mathicgb-unit-tests
    test/F4MatrixBuilder.cpp
    test/F4MatrixReducer.cpp
    test/MathicIO.cpp
    test/MonoMonoid.cpp
    test/PrimeField.cpp
    test/QuadMatrixBuilder.cpp
    test/Range.cpp
    test/Scanner.cpp
    test/SparseMatrix.cpp
    test/gb-test.cpp
    test/ideals.hpp test/ideals.cpp
    test/mathicgb.cpp
    test/poly-test.cpp
    test/testMain.cpp
    )

  ################################
  # add gtest testing ############
  ################################
  if(NOT GTEST_FOUND)
    find_package(GTest)
  endif()
  include(GoogleTest)
  gtest_discover_tests(mathicgb-unit-tests TEST_PREFIX unit-tests:)

  if(GTEST_FOUND)
    target_link_libraries(mathicgb-unit-tests mathicgb GTest::GTest GTest::Main)
  else()
    include(FetchContent)
    FetchContent_Declare(googletest
      GIT_REPOSITORY https://github.com/google/googletest.git
      GIT_TAG        release-1.11.0
      )
    FetchContent_MakeAvailable(googletest)

    target_link_libraries(mathicgb-unit-tests mathicgb gtest)
    target_include_directories(mathicgb-unit-tests PRIVATE
      ${googletest_SOURCE_DIR}/googletest/include
      ${googletest_SOURCE_DIR}/googletest/src
      ${googletest_SOURCE_DIR}/googletest
      )
  endif()
endif()

## mathicgb 1.0~git20211216

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(mathicgb VERSION 1.0 LANGUAGES CXX)

option(enable_mgb "Build mgb" ON)
option(with_tbb "use TBB for multithreading" auto)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

find_package(Threads 2.1 REQUIRED QUIET)
find_package(Memtailor   REQUIRED)
find_package(Mathic      REQUIRED)
if(with_tbb)
  find_package(TBB       REQUIRED)
elseif(with_tbb STREQUAL auto)
  find_package(TBB)
  set(with_tbb ${TBB_FOUND})
endif()

add_library(memtailor STATIC IMPORTED)
set_target_properties(memtailor PROPERTIES
  IMPORTED_LOCATION             "${MEMTAILOR_LIBRARIES}"
  INTERFACE_INCLUDE_DIRECTORIES "${MEMTAILOR_INCLUDE_DIR}")

add_library(mathic STATIC IMPORTED)
set_target_properties(mathic PROPERTIES
  IMPORTED_LOCATION             "${MATHIC_LIBRARIES}"
  INTERFACE_INCLUDE_DIRECTORIES "${MATHIC_INCLUDE_DIR}")

add_compile_options(
  -DHAVE_CXX11=1
  -DPACKAGE_NAME="${PROJECT_NAME}"
  -DPACKAGE_TARNAME="${PROJECT_NAME}"
  -DPACKAGE_VERSION="${PROJECT_VERSION}"
  -DPACKAGE_STRING="${PROJECT_NAME} ${PROJECT_VERSION}"
  -DPACKAGE_BUGREPORT=""
  -DPACKAGE_URL=""
  -DPACKAGE="${PROJECT_NAME}"
  $<$<NOT:$<BOOL:${with_tbb}>>:-DMATHICGB_NO_TBB>
  )

add_subdirectory(src)

set_target_properties(mathicgb PROPERTIES PUBLIC_HEADER src/mathicgb.h)

install(TARGETS mathicgb LIBRARY DESTINATION lib)
install(DIRECTORY src/mathicgb
  DESTINATION include
  FILES_MATCHING PATTERN "*.hpp" PATTERN "*.h"
  )
install(FILES doc/mgb.1 TYPE MAN)
install(FILES README.md gpl-2.0.txt gpl-3.0.txt
  DESTINATION licenses/mathicgb
  )

if(enable_mgb)
  add_executable(mgb
    src/cli/GBMain.cpp
    src/cli/CommonParams.hpp   src/cli/CommonParams.cpp
    src/cli/GBAction.hpp       src/cli/GBAction.cpp
    src/cli/GBCommonParams.hpp src/cli/GBCommonParams.cpp
    src/cli/MatrixAction.hpp   src/cli/MatrixAction.cpp
    src/cli/SigGBAction.hpp    src/cli/SigGBAction.cpp
    src/cli/HelpAction.hpp     src/cli/HelpAction.cpp
    )
  target_link_libraries(mgb mathicgb)
  install(TARGETS mgb RUNTIME DESTINATION bin)
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -62,12 +62,9 @@
   )
 
 target_link_libraries(mathicgb
-  $<$<BOOL:${with_tbb}>:${TBB_LIBRARIES}>
   memtailor mathic Threads::Threads
+  $<$<BOOL:${with_tbb}>:TBB::tbb>
   )
-
-target_include_directories(mathicgb PUBLIC
-  $<$<BOOL:${with_tbb}>:${TBB_INCLUDE_DIRS}>)
 
 target_include_directories(mathicgb PUBLIC
   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>

=== debian/changelog ===
mathicgb (1.0~git20211216-3build1) jammy; urgency=medium

  * No-change rebuild for libtbb soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Mar 2022 10:07:01 +0100

mathicgb (1.0~git20211216-3) unstable; urgency=medium

  * debian/copyright
    - Update my copyright years.
  * debian/tests/unittest
    - Drop "-std=gnu++11" to fix failing test due to lack of class
      template argument deduction before C++17.

 -- Doug Torrance <dtorrance@debian.org>  Thu, 10 Feb 2022 00:12:08 -0500

mathicgb (1.0~git20211216-2) unstable; urgency=medium

  * debian/patches/tbb-2021.patch
    - Add patch to support TBB 2021.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 09 Feb 2022 16:41:27 -0500

mathicgb (1.0~git20211216-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Update my email address; now a Debian Developer.
  * debian/copyright
    - Update my email address and copyright years.
  * debian/upstream/metadata
    - Add "---" to signal document start.
    - Fix case in Bug-Database URL.
    - Add Bug-Submit URL.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 22 Dec 2021 09:23:37 -0500

mathicgb (1.0~git20211001-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Update Maintainer to Debian Math Team.
    - Update Vcs-* fields (debian-science -> debian-math).
  * debian/patches/include-limits.patch
    - Remove patch; applied upstream.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sun, 07 Nov 2021 17:00:14 -0500

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: mathicgb
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Doug Torrance <dtorrance@piedmont.edu>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Uploaders: Doug Torrance <dtorrance@debian.org>
 Build-Depends: debhelper-compat (= 13),
                libgtest-dev,
                libmathic-dev,
@@ -11,8 +11,8 @@
 Standards-Version: 4.6.0
 Section: math
 Homepage: https://github.com/Macaulay2/mathicgb
-Vcs-Git: https://salsa.debian.org/science-team/mathicgb.git
-Vcs-Browser: https://salsa.debian.org/science-team/mathicgb
+Vcs-Git: https://salsa.debian.org/math-team/mathicgb.git
+Vcs-Browser: https://salsa.debian.org/math-team/mathicgb
 Rules-Requires-Root: no
 
 Package: mathicgb

## mathicgb 1.0~git20220311

=== debian/changelog ===
mathicgb (1.0~git20220311-2) unstable; urgency=medium

  * debian/patches/no-tbb-assert.patch
    - New patch; include <cassert> when not building with TBB support.
  * debian/patches/tbb-32-bit.patch
    - New patch; detect TBB 2021 on 32-bit systems.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 16 Mar 2022 23:12:31 -0400

mathicgb (1.0~git20220311-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/gbp.conf
    - Add file; sets default Debian branch to DEP-14 recommended
     "debian/latest".
  * debian/patches/tbb-2021.patch
    - Remove patch; TBB 2021 is now supported upstream.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 11 Mar 2022 14:39:03 -0500

mathicgb (1.0~git20220225-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Only include libtbb-dev in Build-Depends in Linux; it isn't available
      in Hurd or kFreeBSD.
    - Exclude libgtest-dev with nocheck build profile.
  * debian/libmathicgb-dev.install
    - Install all header files, as this release includes more than just
      mathicgb.h.
  * debian/rules
    - Build without gtest when "nocheck" in DEB_BUILD_OPTIONS.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 02 Mar 2022 22:39:39 -0500

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Doug Torrance <dtorrance@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               libgtest-dev,
+               libgtest-dev <!nocheck>,
                libmathic-dev,
                libmemtailor-dev,
-               libtbb-dev,
+               libtbb-dev [linux-any],
                pkg-config
 Standards-Version: 4.6.0
 Section: math

## mathicgb 1.0~git20220426

=== debian/changelog ===
mathicgb (1.0~git20220426-2) unstable; urgency=medium

  * debian/control
    - Bump Standards-Version to 4.6.1
  * debian/patches/libatomic.patch
    - New patch; link against libatomic to avoid build failures on armel
      and mipsel.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 14 Jun 2022 00:17:29 -0400

mathicgb (1.0~git20220426-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/patches/{no-tbb-assert,tbb-32-bit}.patch
    - Remove patches; applied upstream

 -- Doug Torrance <dtorrance@debian.org>  Sun, 08 May 2022 20:47:38 -0400
